//   ͔[łȂR[fBÔߗv
//-----------------------------------------------------------------------------
//  2009.09.29
//  E}CiXɑϐ,֐]łĂȂ (-̎͐ƌߍł)
//  2009.09.28
//  EJM([,])PʂƂēǂݔ΂BRg
//  2009.09.27
//  EzO̕oĂƂȍ~̉͂ł؂Ă邽
//    # ȂǖΉCRgɂȂ邱ƂɋCÂ
//    ȑO̎͐Ƃď
//    Ȃ{͂łB
//    sɖΉꍇ̓G[ɂȂ̂łƂ肠
//  E@=2 ]łȂ(ÖٕϐɖłȂ)u
//  EVariant  EXP\LړƕɂȂĂ܂BStrToFloatgp
//  EEng\LΉ 2arccos  2*arccos ł͂Ȃ 2a(=2E-18) * rccos œǂł܂po
//  2009.09.26
//  EEng\L(M KAT e Ȃ)ɑΉ
//  2009.09.25
//  EExtended ł Variant ł܂łłȂBVariant ɕύX
//  E[U[֐(1ȏ̈K{)̓o^Ɨpɐ()
//    [U[֐`̒ŕʂ̃[U[֐gĂĂ
//  2009.09.24
//  E2a Ƃ 2() ̏ꍇ 2*a Ƃ 2*() Ƃĕ]悤ɂ
//    ł 2ab  2*ab ɂȂĂ܂(ϐabČôA)
//  2009.09.16
//  EN̒`ς݊֐ďoɑΉ(ďô݁B̂Ȃ)
//  Eϐ̒`ɑΉ,ϐgpvZɑΉ
//  EȂꍇ͒OvZʕێϐuAnsvɕێˁu@vɕύX(2009.09.24)
//  2009.09.15
//  ECɂASYT̎̕] +-*/() |
//    Expression,Term,Factor̍ċAďoB킩₷B
//  E(\),]($),ׂ(^),1̒`ς݊֐ďoɑΉ
//-----------------------------------------------------------------------------
//  2009.09.14
//  EZq,퉉Zq̃X^bNgpĂ_ł͐s...
//  2009.09.08
//  E̓ǂݎvbscript̐K\NXgp
//  2009.09.07
//  Ehttp://www.ac.cyberhome.ne.jp/~v-tails/delphi/index.html
//    vtcalcs.exe (\[Xt)f炵BfobOs\炵׋ɂȂ
//    DecimalDouble؂ւĐvZ郂W[(2005-04-16G)
//    Delphiɖ|JnBvZr̕\
//-----------------------------------------------------------------------------
//  9999.99.99
//      𐔎̈ꕔƂĔF
//      % 𐔎̈ꕔƂĔF
//      C^[tF[X̌
//
//      [while
//      sx]ł΋[IɎvZł邩
//      Ał蓮łłȂȂ
//
//      (Pʂ̌vZ)
//      
//      ̂܂܌vZƂ
//
//      ʍʂ̍ɓƗŌ܂鋉̌vZ
//      ֐肪ւځBExtractedExpr ɎŜĂقȂ
//-----------------------------------------------------------------------------


unit EvalUnit;

interface

uses
    SysUtils, Classes, Math, MiscUnit, VBScript_RegExp_55_TLB;

//=============================================================================
type
    TCharSet = set of Char;

type
    TEvaluator = class
    private
        FTokenizer: TTokenizer;
        FVariables: TVariableList;
        FFunctions: TFunctionList;
        FStrBuf: TStringList;
        FLog: TStringList;
        function Number(): Variant;
        function Factor(const Depth: Integer): Variant;
        function Term(const Depth: Integer): Variant;
        function Expression(const Depth: Integer): Variant;
        procedure ERROR(const AChar, AMsg: String);
        function IsCharIn(const AChar: String; const ASet: TCharSet): Boolean;
        function GetLeftExpr(): String;
        function GetExtractedExpr(): String;
    public
        constructor Create();
        destructor Destroy(); override;
    public
        function Execute(const Expr: String; var AResult: Variant): Boolean;
        procedure ClearVariables();
        property Variables: TVariableList read FVariables;
        property Functions: TFunctionList read FFunctions;
        property Log: TStringList read FLog;
        property LeftExpr: String read GetLeftExpr;
        property ExtractedExpr: String read GetExtractedExpr;
    end;

type
    EEvaluatorError = class(Exception);

implementation

//-----------------------------------------------------------------------------
procedure TEvaluator.ERROR(const AChar, AMsg: String);
begin
    raise EEvaluatorError.CreateFmt('%s ["%s" %s]', [ExtractedExpr, AChar, AMsg]);
end;

//-----------------------------------------------------------------------------
function TEvaluator.IsCharIn(const AChar: String; const ASet: TCharSet): Boolean;
begin
    Result := (AChar <> '') and (AChar[1] in ASet);
end;

//-----------------------------------------------------------------------------
constructor TEvaluator.Create();
begin
    FTokenizer := TTokenizer.Create();
    FVariables := TVariableList.Create();
    FFunctions := TFunctionList.Create();
    FStrBuf := TStringList.Create();
    FLog := TStringList.Create();
end;

//-----------------------------------------------------------------------------
destructor TEvaluator.Destroy();
begin
    FTokenizer.Free();
    FVariables.Free();
    FFunctions.Free();
    FStrBuf.Free();
    FLog.Free();
end;

//-----------------------------------------------------------------------------
//  ]҂̎o
function TEvaluator.GetLeftExpr(): String;
begin
    Result := FTokenizer.Expression;
end;

//-----------------------------------------------------------------------------
//  ]ς݂̎o
function TEvaluator.GetExtractedExpr(): String;
begin
    Result := FTokenizer.Extracted;
end;

//-----------------------------------------------------------------------------
//  
function TEvaluator.Number(): Variant;
var
    LToken: String;
    LChar: String;
    LEng: Variant;
begin
    LEng := 1;

    //  EXP\Őǂł݂
    LToken := FTokenizer.GetNumberExp();

    //  ۂEXP\Ȃ炻̂܂܍̗p
    if (AnsiPos('E', UpperCase(LToken)) > 0) then
    begin
        LToken := FTokenizer.GetNumberExp(False);
    end
    //  łȂȂENG\œǂݎ
    //  ȂƂEXP\ł͂Ȃ̂ENG\łȂĂ̂܂܍̗p
    else
    begin
        LToken := FTokenizer.GetNumberEng(False);
        //  𒲂ׂ
        LChar := FTokenizer.RegMatch(LToken, REG_ENG + '+$');
        if (LChar <> '') then
        begin
            //  菜
            LToken := StringReplace(LToken, LChar, '', []);
            //  ɕϊ
            if (LChar = 'Y') then LEng := 1E24 else
            if (LChar = 'Z') then LEng := 1E21 else
            if (LChar = 'E') then LEng := 1E18 else
            if (LChar = 'P') then LEng := 1E15 else
            if (LChar = 'T') then LEng := 1E12 else
            if (LChar = 'G') then LEng := 1E9 else
            if (LChar = 'M') then LEng := 1E6 else
            if (LChar = 'k') then LEng := 1E3 else
            if (LChar = 'h') then LEng := 1E2 else
            if (LChar = 'da') then LEng := 1E1 else
            if (LChar = 'd') then LEng := 1E-1 else
            if (LChar = 'c') then LEng := 1E-2 else
            if (LChar = 'm') then LEng := 1E-3 else
            if (LChar = '') then LEng := 1E-6 else
            if (LChar = 'n') then LEng := 1E-9 else
            if (LChar = 'p') then LEng := 1E-12 else
            if (LChar = 'f') then LEng := 1E-15 else
            if (LChar = 'a') then LEng := 1E-18 else
            if (LChar = 'z') then LEng := 1E-21 else
            if (LChar = 'y') then LEng := 1E-24 else
            ;
        end;
    end;
    //  
    Result := StrToFloat(LToken) * LEng;
end;

//-----------------------------------------------------------------------------
//  q|()
function TEvaluator.Factor(const Depth: Integer): Variant;
var
    LChar: String;
    LRite: Variant;
    LToken: String;
    LArgs: array of Variant;
    LEvaluator: TEvaluator;
    LFunction: TFunction;
    i: Integer;
begin
    Result := 0;
    LChar := FTokenizer.GetChar();
    //  ǑvZ
    if (LChar = '@') then
    begin
        FTokenizer.GetChar(False);
        Result := FVariables.Values['@'];
    end
    //  ʂoĂ玮͂BŉEʂŏI
    else
    if (LChar = '(') then
    begin
        //  ʂǂݔ΂
        FTokenizer.GetChar(False);
        //  ʂ̒]
        Result := Expression(Depth + 1);
        //  EʂmF
        LChar := FTokenizer.GetChar();
        if (LChar = ')') then FTokenizer.GetChar(False)
        else
        begin
            //ERROR(')', 's');
            FTokenizer.InsChar(')');
            FTokenizer.GetChar(False)
        end;
    end
    //  
    else
    if IsCharIn(LChar, ['0'..'9','.']) then
    begin
        Result := Number();
        //  ̈ꕶĂ݂
        LChar := FTokenizer.GetChar();
        //  Zۂꍇ͏Zŕ]
        if IsCharIn(LChar, ['a'..'z','A'..'Z','_','(']) then
        begin
            FTokenizer.InsChar('*');
        end;
    end
    //  ϐ֐
    else
    if IsCharIn(LChar, ['a'..'z','A'..'Z','_']) then
    begin
        LToken := FTokenizer.GetWord(False);
        //  ̕ǂł݂
        LChar := FTokenizer.GetChar();
        //  ֐
        if (LChar = '(') then
        begin
            //  p̔z
            SetLength(LArgs, 0);
            //  ʂǂݔ΂
            FTokenizer.GetChar(False);
            //  o
            SetLength(LArgs, Length(LArgs) + 1);
            LArgs[High(LArgs)] := Expression(Depth + 1);
            //  ̕ǂł݂
            LChar := FTokenizer.GetChar();
            //  ̂
            while (LChar = ',') do
            begin
                FTokenizer.GetChar(False);
                SetLength(LArgs, Length(LArgs) + 1);
                LArgs[High(LArgs)] := Expression(Depth + 1);
                LChar := FTokenizer.GetChar();
            end;
            //  EʂmF
            LChar := FTokenizer.GetChar();
            if (LChar = ')') then FTokenizer.GetChar(False)
            else
            begin
                //ERROR(')', 's');
                FTokenizer.InsChar(')');
                FTokenizer.GetChar(False)
            end;

            //  ܂łA֐̈Ɋ֐荞łԂ͂Ȃ
            //  ֐̕]ɕʂ̊֐]KvȂ
            //  lɕϐ̕]KvȂ
            //  Ɉ͕]IĂ邽

            //  g֐]
            if not EvalFunc(LToken, LArgs, Result) then
            //  [U[`֐]
            begin
//
                //  ֐o
                LFunction := FFunctions.Functions[LToken];
                //  ֐炸
                if (LFunction = nil) then
                begin
                    ERROR(LToken, '֐`');
                end
                //  ̐r
                else
                if (Length(LArgs) <> LFunction.Param.Count) then
                begin
                    ERROR(LToken, 's');
                end
                //  悢
                else
                begin
                    LEvaluator := nil;
                    try
                        LEvaluator := TEvaluator.Create();
                        //  ̎_œo^ς݂̕ϐnĂ
                        LEvaluator.Variables.Assign(Self.Variables);
                        //  ̎_œo^ς݂̊֐nĂ
                        LEvaluator.Functions.Assign(Self.Functions);
                        //  ϐƂēo^(o^ςݕϐɂԂĂꍇ͈D)
                        for i := 0 to High(LArgs) do
                        begin
                            LEvaluator.Variables.Values[LFunction.Param[i]] := LArgs[i];
                        end;
                        //  ]
                        if (not LEvaluator.Execute(LFunction.Expression, Result)) then
                        begin
                            ERROR(LToken, ']s(' + Result + ')');
                        end;
                    finally
                        LEvaluator.Free();
                    end;
                end;
//
            end;
        end
        //  ϐ
        else
        begin
            Result := FVariables.Values[LToken];
        end;
    end
    //  p
    else
    begin
        ERROR(LChar, 'Ή');
    end;

    //  ̕ǂł݂
    LChar := FTokenizer.GetChar();
    //  P
    if (LChar = '[') then
    begin
        LChar := FTokenizer.GetDimension(False);
    end;

    //  ̕ǂł݂
    LChar := FTokenizer.GetChar();
    //  ׂ
    if (LChar = '^') then
    begin
        FTokenizer.GetChar(False);
        LRite := Factor(Depth + 1);
        Result := Power(Result, LRite);
    end;
end;
//-----------------------------------------------------------------------------
//  q([*/\$]q)*
function TEvaluator.Term(const Depth: Integer): Variant;
var
    LChar: String;
    LRite: Variant;
begin
    Result := Factor(Depth + 1);
    while True do
    begin
        LChar := FTokenizer.GetChar();
        //  |Z
        if (LChar = '*') then
        begin
            FTokenizer.GetChar(False);
            LRite := Factor(Depth + 1);
            Result := Result * LRite;
        end
        //  Z
        else
        if (LChar = '/') then
        begin
            FTokenizer.GetChar(False);
            LRite := Factor(Depth + 1);
            Result := Result / LRite;
        end
        //  
        else
        if (LChar = '\') then
        begin
            FTokenizer.GetChar(False);
            LRite := Factor(Depth + 1);
            Result := Trunc(Result / LRite);
        end
        //  ]
        else
        if (LChar = '$') then
        begin
            FTokenizer.GetChar(False);
            LRite := Factor(Depth + 1);
            Result := Result - Trunc(Result / LRite) * LRite;
        end
        //  I(mȂZqɗ)
        else
        begin
            //ERROR(Format('Term(); Ή̋Lq %s', [LChar]));
            Break;
        end;
    end;
end;
//-----------------------------------------------------------------------------
//  [+-]([+-])*
function TEvaluator.Expression(const Depth: Integer): Variant;
var
    LChar: String;
    LRite: Variant;
begin
    //  ŏ̍ǂ
    LChar := FTokenizer.GetChar();
    if (LChar = '-') then
    begin
        LChar := FTokenizer.GetChar(False);
        Result := - Term(Depth + 1);
    end
    else
    if (LChar = '+') then
    begin
        LChar := FTokenizer.GetChar(False);
        Result := Term(Depth + 1);
    end
    else
    begin
        Result := Term(Depth + 1);
    end;
    //  ȍ~̍ǂ
    while True do
    begin
        LChar := FTokenizer.GetChar();
        //  a
        if (LChar = '+') then
        begin
            FTokenizer.GetChar(False);
            LRite := Term(Depth + 1);
            Result := Result + LRite;                         
        end
        //  
        else
        if (LChar = '-') then
        begin
            FTokenizer.GetChar(False);
            LRite := Term(Depth + 1);
            Result := Result - LRite;
        end
        //  I(mȂZqɗ)
        else
        begin
            //ERROR(Format('Ή̋Lq %s', [LChar]));
            Break;
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  s
function TEvaluator.Execute(const Expr: String; var AResult: Variant): Boolean;
var
    LChar: String;
    LName: String;
    LCheck: Boolean;
    LParam: String;
    LExpr: String;
    i: Integer;
begin
    //  
    Result := False;
    FLog.Clear();
    //FVariables.Clear();
    FTokenizer.Expression := Expr;

    //  Öق̌vZʗpϐBIɕϐ`ĂȂ΂ɓ˂
    LName := '@';

    //  Iɕϐw邩ǂ
    LChar := FTokenizer.GetChar();

    //  @ ւ̖Iȑu
    if (LChar = '@') then
    begin
        FTokenizer.GetChar(False);
        LChar := FTokenizer.GetChar();
        if (LChar = '=') then
        begin
            FTokenizer.GetChar(False);
        end
        //  Ĉ̂Ōɖ߂
        else
        begin
            FTokenizer.Expression := Expr;
            LName := '@'
        end;
    end

    //  ϐ֐̒`()
    else
    if IsCharIn(LChar, ['a'..'z','A'..'Z','_']) then
    begin
        LName := FTokenizer.GetWord(False);
        //  ̕ǂł݂
        LChar := FTokenizer.GetChar();
        //  ֐()
        if (LChar = '(') then
        begin
//
            LCheck := False;
            LChar := FTokenizer.GetChar(False);
            //  Eʂ̒O܂ŕo(EʂȂƕS...)
            //  ꂪ̂͂
            LParam := FTokenizer.RegMatch(FTokenizer.Expression, '^[^)]+');
            //  NX̃oɔ`ł̂œǂݎ̂Ă
            //  CǂƂ肠
            FTokenizer.Expression := StringReplace(FTokenizer.Expression, LParam, '', []);
            //  ͉̎Eʂ̂͂
            LChar := FTokenizer.GetChar(False);
            if (LChar = ')') then
            begin
                //  ̎́̂͂
                LChar := FTokenizer.GetChar(False);
                if (LChar = '=') then
                begin
                    //  ܂cĂΑ1֖˔j
                    FTokenizer.SkipBlank();
                    LExpr := FTokenizer.Expression;
                    if (LExpr <> '') then
                    begin
                        LCheck := True;

                        //  ƈǂ
                        FStrBuf.CommaText := LParam;
                        if (FStrBuf.Count > 0) then
                        begin
                            for i := 0 to FStrBuf.Count - 1 do
                            begin
                                //  1łϐ`̈łȂ̂΃AEg
                                FTokenizer.Expression := FStrBuf[i];
                                LChar := FTokenizer.GetChar();
                                if IsCharIn(LChar, ['a'..'z','A'..'Z','_']) then
                                begin
                                    LChar := FTokenizer.GetWord(False);
                                    if (LChar = '') then
                                    begin
                                        LCheck := False;
                                        Break;
                                    end;
                                    FStrBuf[i] := LChar;
                                end;
                            end;
                        end;
                        //  ЂƂ疳ʂȋ󔒂邩mȂ̂łꂢɂĂ
                        LParam := FStrBuf.CommaText;
                    end;
                end;
                //  ֐ۂ
                if (LCheck) then
                begin
                    //  ֐o^Ẵ\bh𔲂
                    FFunctions.RegistFunction(LName, LParam, LExpr);
                    AResult := '[֐`]';
                    Result := True;
                    Exit;
                end
                //  ֐Ȃ
                else
                begin
                    //  ǂݔ΂Ă܂ɖ߂ĕʂɕ]𑱂
                    FTokenizer.Expression := Expr;
                    LName := '@'
                end;
            end;
//
        end
        //  ϐ`(vZʂێ)
        else
        if (LChar = '=') then
        begin
            //  LNameɂ͕ϐĂ
            //  u=vǂݔ΂΁A͐cĂ邾B
            FTokenizer.GetChar(False);
        end
        //  ǂłȂ(`Ȃ)
        else
        begin
            //  ǂݔ΂Ă܂ɖ߂ĕʂɕ]𑱂
            FTokenizer.Expression := Expr;
            LName := '@'
        end;
    end;

    //  ۂȂ
    if (FTokenizer.Expression = '') then
    begin
        AResult := ExtractedExpr + ' ' + '[Ȃł...]';
    end
    else
    begin
        try
            //  1ڂZq̏ꍇ́ǍvZʂɑ΂鉉ZƂƂɂ
            //  +  - ͕ʂ̐̉\̂őΏۊO  
            LChar := FTokenizer.GetChar();
            if (IsCharIn(LChar, ['*','/','\','$','^'])) then
            begin
                FTokenizer.InsChar('@');
            end;

            //  vZ
            AResult := Expression(0);
            //  ϐXV
            FVariables.Values[LName] := AResult;
            Result := True;
        except
            on E: EEvaluatorError do AResult := E.Message;
            on E: Exception do AResult := ExtractedExpr + ' ' + E.Message;
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  ϐNA
procedure TEvaluator.ClearVariables();
begin
    FVariables.Clear();
end;


end.

