//-----------------------------------------------------------------------------
//  2009.09.29
//      `ς݂̕ϐƊ֐ʃt@CɂċNǂݍ݁A㏑֎~ɂ
//  2009.09.27
//      SynUnit ̐K\@\gĂ݂
//  2009.09.25
//      ȂƂȂ SynEdit ̍\@\gĂ݂
//      Delphi̊֐ƃ[U[`֐̌vZʂr̂ɕ֗
//  2009.09.24
//      vtcalcs.exe ̂悤ɃGfB^ EntervZł悤ɂȂBƁB
//      GfB^@\ SynEdit2.0.6 (http://SynEdit.SourceForge.net/) ɂ܂ 
//-----------------------------------------------------------------------------

unit MainUnit;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms, StdCtrls, ExtCtrls, ComCtrls, Menus, 
  SynEdit, SynEditHighlighter, SynHighlighterPas, SynHighlighterGeneral,
  SynEditMiscClasses, SynEditRegexSearch, ToolWin,
  EvalUnit, MiscUnit;

type
  TMainForm = class(TForm)
    SynEdit1: TSynEdit;
    Splitter1: TSplitter;
    PageControl1: TPageControl;
    TabResult: TTabSheet;
    TabVariable: TTabSheet;
    TabFunction: TTabSheet;
    MemResults: TMemo;
    SynGeneralSyn1: TSynGeneralSyn;
    MemVariables: TMemo;
    MemFunctions: TMemo;
    MainMenu: TMainMenu;
    MenuHelp: TMenuItem;
    MenuVersion: TMenuItem;
    Bevel1: TBevel;
    SynEditRegexSearch1: TSynEditRegexSearch;
    StatusBar1: TStatusBar;
    CoolBar1: TCoolBar;
    Edit1: TEdit;
    TabDef: TTabSheet;
    MemDef: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SynEdit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MenuVersionClick(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
  private
    FDatFilePath: String;
    FDefFilePath: String;
    FTokenizer: TTokenizer;
    FEval: TEvaluator;
    FStrBuf: TStringList;
    function Evaluate(const ALine: String): String; overload;
    procedure Evaluate(Strings: TStrings); overload;
    procedure Search(const AText: String; const AForward: Boolean);
  public
    { Public 錾 }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses
    SynEditTypes, Info;

//-----------------------------------------------------------------------------
procedure TMainForm.MenuVersionClick(Sender: TObject);
begin
    OpenInfoForm();
end;

//-----------------------------------------------------------------------------
procedure TMainForm.FormCreate(Sender: TObject);
begin
    SetFormCaption(Self);
    //  NXCX^X쐬
    FTokenizer := TTokenizer.Create();
    FEval := TEvaluator.Create();
    FStrBuf := TStringList.Create();
    //  ֌Wt@CpX
    FDatFilePath := ChangeFileExt(ParamStr(0), '.txt');
    FDefFilePath := ChangeFileExt(ParamStr(0), '.def');
    //  ֌Wt@Cǂݍ
    if (FileExists(FDatFilePath)) then SynEdit1.Lines.LoadFromFile(FDatFilePath);
    if (FileExists(FDefFilePath)) then MemDef.Lines.LoadFromFile(FDefFilePath);
    //  `ς݊֐Aϐ]
    FEval.Functions.ProtectMode := True;
    FEval.Variables.ProtectMode := True;
    Evaluate(MemDef.Lines);
    FEval.Functions.ProtectMode := False;
    FEval.Variables.ProtectMode := False;
    //  \ݒ
    FStrBuf.Assign(SynGeneralSyn1.KeyWords);
    FStrBuf.AddStrings(FEval.Functions.List);
    FStrBuf.AddStrings(FEval.Variables.List);
    FStrBuf.Sort();
    //FStrBuf.SaveToFile(ChangeFileExt(ParamStr(0), '.log'));
    SynGeneralSyn1.KeyWords.Assign(FStrBuf);
end;

//-----------------------------------------------------------------------------
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    SynEdit1.Lines.SaveToFile(FDatFilePath);
    FTokenizer.Free();
    FEval.Free();
    FStrBuf.Free();
end;

//-----------------------------------------------------------------------------
procedure TMainForm.Evaluate(Strings: TStrings);
var
    i: Integer;
    LLine: String;
begin
    for i := 0 to Strings.Count - 1 do
    begin
        LLine := Strings[i];
        Strings[i] := Evaluate(LLine);
    end;
end;

//-----------------------------------------------------------------------------
function TMainForm.Evaluate(const ALine: String): String;
var
    LResult: Variant;
    LAns: String;
    LChar: String;
begin
    //  ǑvZʂ()̂Ă
    FTokenizer.Expression := ALine;
    FTokenizer.Remove(CHR_RESULT + '.*$');
    Result := FTokenizer.Expression;

    //  CRg
    LChar := FTokenizer.GetChar();
    if (LChar = CHR_LINECOMMENT) then
    begin
        Exit;
    end
    //  ȂȂȂ
    else
    if (Result = '') then
    begin
        //  I
        Exit;
    end
    //  ]
    else
    if (FEval.Execute(Result, LResult)) then
    begin
        LAns := LResult;
        MemResults.Clear();
    end
    //  ]s
    else
    begin
        LAns := LResult;//'Err';
        MemResults.Text := LResult;
    end;

    //  ]o
    MemResults.Lines.Add('[] ' + FEval.ExtractedExpr);
    MemResults.Lines.Add('[c] ' + FEval.LeftExpr);
    MemResults.Lines.Add('[] ' + LAns);
    //  ܂ł̕ϐ̓eo
    MemVariables.Clear();
    FEval.Variables.ToString(MemVariables.Lines);
    //  ֐o^󋵂o
    MemFunctions.Clear();
    FEval.Functions.ToString(MemFunctions.Lines);

    Result := Result + CHR_RESULT + LAns;
end;

//-----------------------------------------------------------------------------
procedure TMainForm.SynEdit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
    LEdit: TSynEdit;
    LLine: String;
    //i: Integer;
begin
    LEdit := TSynEdit(Sender);

    if (Key = VK_RETURN) then
    begin
        //  ͋p
        Key := 0;

MemResults.Lines.BeginUpdate();
MemVariables.Lines.BeginUpdate();
MemFunctions.Lines.BeginUpdate();

        //  Shift ȂAݍsɌԂ󂯂
        if (Shift = [ssShift]) then
        begin
            if (LEdit.CaretY < LEdit.Lines.Count) then LEdit.Lines.Insert(LEdit.CaretY - 1, '');
        end

        //  Ctrl ȂAݍs̕]Ă̍ŝ܂
        else
        if (Shift = [ssCtrl]) then
        begin

            LLine := LEdit.LineText;
            LEdit.LineText := Evaluate(LLine);
        end

        //  Alt ȂASsĕ]Ă̍ŝ܂
        else
        if (Shift = [ssAlt]) then
        begin
            //for i := 0 to LEdit.Lines.Count - 1 do
            //begin
            //    LLine := LEdit.Lines[i];
            //    LEdit.Lines[i] := Evaluate(LLine);
            //end;
            Evaluate(LEdit.Lines);
        end

        //  EnterȃL[ȂAݍs]Asֈړ
        else
        begin
            LLine := LEdit.LineText;
            LEdit.LineText := Evaluate(LLine);

            if (LEdit.CaretY >= LEdit.Lines.Count) then LEdit.Lines.Add('');
            LEdit.CaretY := LEdit.CaretY + 1;
        end;

MemResults.Lines.EndUpdate();
MemVariables.Lines.EndUpdate();
MemFunctions.Lines.EndUpdate();

    end
    else
    begin
        if (Shift = [ssShift]) then StatusBar1.SimpleText := 'SHIFT+ENTERŋsǉ'
        else if (Shift = [ssCtrl]) then StatusBar1.SimpleText := 'CTRL+ENTERŌvẐ'
        else if (Shift = [ssAlt]) then StatusBar1.SimpleText := 'ALT+ENTERőSsvZ'
        else StatusBar1.SimpleText := 'ENTERŌvZĎsɈړ';

    end;
end;

//-----------------------------------------------------------------------------
//  
procedure TMainForm.Search(const AText: String; const AForward: Boolean);
var
    LEdit: TSynEdit;
    LOptions: TSynSearchOptions;
    LFound: Boolean;
begin
    LEdit := SynEdit1;

    //  IvV쐬
    LOptions := [];
    //  u
    //LOptions := [ssoPrompt, ssoReplace, ssoReplaceAll];
    //  
    if (not AForward) then Include(LOptions, ssoBackwards);
    //  啶
    //Include(LOptions, ssoMatchCase);
    //  J[\ʒu
    //Include(LOptions, ssoEntireScope);
    //  I𕶎񂩂
    //Include(LOptions, ssoSelectedOnly);
    //  P
    //Include(LOptions, ssoWholeWord);

    //  s
    LFound := False;
    if (AText <> '') then
    begin
        try
            LFound := (LEdit.SearchReplace(AText, '', LOptions) <> 0);
        except
        on E: Exception do
            StatusBar1.SimpleText := E.Message;
        end;
    end;

    //  s
    if (not LFound) then
    begin
        //  ŏɖ߂
        if (AForward) then
        begin
            LEdit.CaretXY := BufferCoord(0, 0);
        end
        else
        begin
            LEdit.CaretY := LEdit.Lines.Count;
            LEdit.CaretX := Length(LEdit.Lines[LEdit.CaretY - 1]) + 1;
        end;
    end;
end;

//-----------------------------------------------------------------------------
procedure TMainForm.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
    if (Key = #13) then
    begin
        Key := #0;
        Search(Edit1.Text, True);
    end;
end;

end.
