//-----------------------------------------------------------------------------
//  2009.09.29
//  E̊֐ŌvZł̂͑SOɏoBŁAxȂ...
//  E֐ɏ㏑֎~ݒǉ
//  ESynEdit ̃RgFg߂ɍsRg ; ɂ(AsmStyle)
//  2009.09.28
//  E3̊֐ ConvertDeg, DegToRad2 ǉ(xb\̕ϊ)
//    vZ̃eXgɗȔN\̌vZgƂƓxbpo...
//  2009.09.26
//  ETTokenizerEngineering\L̓ǂݏoǉ
//  2009.09.25
//  EExtended ł Variant ł܂łłȂBVariant ɕύX
//  E1̊֐ Exp ǉ
//  E2̊֐ LogN, Max, Min ǉ
//  E[U[`֐ێNX쐬
//  2009.09.23
//  E2̊֐Ƃ GCDALCM ǉ
//  2009.09.16
//  E萔AϐǗNXAǂݎNX𕪗
//  E1̊֐Ƃ DelphiW̊֐ɑΉ
//-----------------------------------------------------------------------------

unit MiscUnit;

interface

uses
    SysUtils, Classes, Math, VBScript_RegExp_55_TLB;

//-----------------------------------------------------------------------------
//  K\
//  L    \d  [0-9]
const
    //  ԃRg
    CHR_AREACOMMENT_BGN = '[';
    CHR_AREACOMMENT_END = ']';
    //  󔒕
    CHR_BLANK = '@ '#9;
    //  K\ňӖꕶ̃Zbg
    REG_SPECIAL_CHARS = ['[',']','(',')','{','}','|','.','?','+','*','^','$','\'];
    //  EXP\L(0.1E-2 )Ɉv
    REG_NUM_EXP = '\d*[.]?\d+([Ee][+-]?\d+)?';    //  tEXP\L(0.1E-2 )Ɉv
    REG_SIGNEDNUM_EXP = '[+-]?' + REG_NUM_EXP;
    //  ENG\L(0.1K )Ɉv
    REG_ENG = '([YZEPTGMkh]|da|[dcmnpfazy])';
    REG_NUM_ENG = '\d*[.]?\d+' + REG_ENG + '?';
    REG_SIGNEDNUM_ENG = '[+-]?' + REG_NUM_ENG;
    //  ϐ֐
    REG_WORD = '[A-Za-z_]+[A-Za-z0-9_]*';
    //  vZ
    CHR_RESULT = #9' ';
    //  CRg
    CHR_LINECOMMENT = ';';
    //  P
    REG_DIMENSION = '[[][^]]*[]]';

//-----------------------------------------------------------------------------
type
    //  ϐf[^
    TVariable = class(TObject)
    public
        Name: String;       //  ϐ
        Value: Variant;     //  ϐl
        Protect: Boolean;   //  True: ㏑֎~
        constructor Create();
    end;

    //  ϐǗNX
    TVariableList = class(TObject)
    private
        FList: TStringList;
        FProtectMode: Boolean;
        function GetVariable(const Name: String): TVariable;
        function GetValue(const Name: String): Variant;
        procedure SetValue(const Name: String; const Value: Variant);
        function GetProtect(const Name: String): Boolean;
        procedure SetProtect(const Name: String; const Value: Boolean);
        function GetCount(): Integer;
        procedure ERROR(const AChar, AMsg: String);
    public
        constructor Create();
        destructor Destroy(); override;
        procedure Clear();
        function GetVariables(const Index: Integer): TVariable; 
        procedure Assign(const Source: TVariableList);
        procedure ToString(Strings: TStrings);
        property Variables[const Name: String]: TVariable read GetVariable;
        property Values[const Name: String]: Variant read GetValue write SetValue;
        property Protects[const Name: String]: Boolean read GetProtect write SetProtect;
        property Count: Integer read GetCount;
        property List: TStringList read FList;
        property ProtectMode: Boolean read FProtectMode write FProtectMode;
    end;

//-----------------------------------------------------------------------------
type
    //  ֐f[^
    TFunction = class(TObject)
    public
        Name: String;           //  ֐
        Param: TStringList;     //  Xg
        Expression: String;     //  
        Protect: Boolean;   //  True: ㏑֎~
        constructor Create();
        destructor Destroy(); override;
    end;

    //  ֐ǗNX
    TFunctionList = class(TObject)
    private
        FList: TStringList;
        FProtectMode: Boolean;
        function GetFunction(const Name: String): TFunction;
        function GetParam(const Name: String): TStringList;
        function GetExpression(const Name: String): String;
        function GetProtect(const Name: String): Boolean;
        procedure SetProtect(const Name: String; const Value: Boolean);
        function GetCount(): Integer;
        procedure ERROR(const AChar, AMsg: String);
    public
        constructor Create();
        destructor Destroy(); override;
        procedure Clear();
        function GetFunctions(const Index: Integer): TFunction;
        function RegistFunction(const Name, Params, Expression: String): Boolean;
        procedure Assign(const Source: TFunctionList);
        procedure ToString(Strings: TStrings);
        property Functions[const Name: String]: TFunction read GetFunction;
        property Params[const Name: String]: TStringList read GetParam;
        property Expressions[const Name: String]: String read GetExpression;
        property Protects[const Name: String]: Boolean read GetProtect write SetProtect;
        property Count: Integer read GetCount;
        property List: TStringList read FList;
        property ProtectMode: Boolean read FProtectMode write FProtectMode;
    end;

//-----------------------------------------------------------------------------
type
    TTokenizer = class(TObject)
    private
        FRegBuf: TRegExp;
        FStrBuf: TStringList;
    private
        FExpression: String;
        FExtracted: String;
        procedure SetExpression(const Value: String);
    public
        constructor Create();
        destructor Destroy(); override;
        //procedure PurgeAreaComment(const S, E: Char);
        procedure Remove(const ARegExp: String);
        function RegMatch(const AText, ARegExp: String): String;
    public
        property Expression: String read FExpression write SetExpression;
        property Extracted: String read FExtracted;
        procedure SkipBlank(const BlankChars: String = CHR_BLANK);
        function GetChar(const ReadOnly: Boolean = True): String;
        procedure InsChar(const AText: String);
        function GetNumberExp(const ReadOnly: Boolean = True): String;
        function GetNumberEng(const ReadOnly: Boolean): String;
        function GetWord(const ReadOnly: Boolean = True): String;
        function GetDimension(const ReadOnly: Boolean = True): String;
    end;

//-----------------------------------------------------------------------------
function EvalFunc(const Name: String; const Args: array of Variant; var AResult: Variant): Boolean;

implementation

//-----------------------------------------------------------------------------
//  UTILITY

//-----------------------------------------------------------------------------
//  ő
//  F CɂASYT
function GCD(const X, Y: Int64): Int64;
begin
    if (Y = 0) then Result := X
    else Result := GCD(Y, X mod Y);
end;

//-----------------------------------------------------------------------------
//  ŏ{
//  F CɂASYT
function LCM(const X, Y: Int64): Int64;
begin
    Result := Abs(X * Y) div GCD(X, Y);
end;

//-----------------------------------------------------------------------------
//  pxxb珬\ɕϊ
//function ConvertDeg(const Deg, Min, Sec: Extended): Extended;
//begin
//    Result := ((Sec / 60) + Min) / 60 + Deg;
//end;

//-----------------------------------------------------------------------------
//  xbWAɕϊ
//function DegToRad2(const Deg, Min, Sec: Extended): Extended;
//begin
//    Result := DegToRad(ConvertDeg(Deg, Min, Sec));
//end;
{
//-----------------------------------------------------------------------------
//  g֐(3)
function EvalFunc3(const Name: String; const Args: array of Variant; var AResult: Variant): Boolean;
var
    LName: String;
    LArg0, LArg1, LArg2: Variant;
    LInt0, LInt1, LInt2: Int64; 
begin
    Result := True;
    LName := LowerCase(Name);
    LArg0 := Args[0];
    LArg1 := Args[1];
    LArg2 := Args[2];
    LInt0 := Trunc(LArg0);
    LInt1 := Trunc(LArg1);
    LInt2 := Trunc(LArg2);

    //  xb\ɕϊ
    //if (LName = 'convertdeg') then AResult := ConvertDeg(LArg0, LArg1, LArg2)

    //  xbWAɕϊ
    //else
    //if (LName = 'degtorad2') then AResult := ConvertDeg(LArg0, LArg1, LArg2)

    //  p
    //else
    Result := False;
end;
}
//-----------------------------------------------------------------------------
//  g֐(2)
function EvalFunc2(const Name: String; const Args: array of Variant; var AResult: Variant): Boolean;
var
    LName: String;
    LArg0, LArg1: Variant; 
    LInt0, LInt1: Int64; 
begin
    Result := True;
    LName := LowerCase(Name);
    LArg0 := Args[0];
    LArg1 := Args[1];
    LInt0 := Trunc(LArg0);
    LInt1 := Trunc(LArg1);

    //  ő
    if (LName = 'gcd') then AResult := GCD(LInt0, LInt1)
    //  ŏ{
    else
    if (LName = 'lcm') then AResult := LCM(LInt0, LInt1)
    //  傫
    else
    if (LName = 'max') then AResult := Max(LArg0, LArg1)
    //  
    else
    if (LName = 'lcm') then AResult := Min(LArg0, LArg1)

    //  Op֐
    else
    if (LName = 'atan2') or (LName = 'arctan2') then AResult := ArcTan2(LArg0, LArg1)

    //  ̊֐̑gݍ킹ŋLqł
    //else
    //if (LName = 'logn') then AResult := LogN(LArg0, LArg1)

    //  p
    else
    Result := False;
end;

//-----------------------------------------------------------------------------
//  g֐(1)
function EvalFunc1(const Name: String; const Arg: Variant; var AResult: Variant): Boolean;
var
    LName: String;
begin
    Result := True;
    LName := LowerCase(Name);

    //  ̑
    if (LName = 'abs') then AResult := Abs(Arg)
    else
    if (LName = 'sign') then AResult := Sign(Arg)
    else
    if (LName = 'sqr') then AResult := Sqr(Arg)
    else
    if (LName = 'sqrt') then AResult := Sqrt(Arg)

    //  ؂グ؂艺
    else
    if (LName = 'ceil') then AResult := Ceil(Arg)
    else
    if (LName = 'floor') then AResult := Floor(Arg)
    else
    if (LName = 'trunc') then AResult := Trunc(Arg)

    //  ΐ
    else
    if (LName = 'exp') then AResult := Exp(Arg)
    else
    if (LName = 'ln') then AResult := Ln(Arg)

    //  pxϊ
    //else
    //if (LName = 'degtorad') then AResult := DegToRad(Arg)
    //else
    //if (LName = 'radtodeg') then AResult := RadToDeg(Arg)

    //  SIN
    else
    if (LName = 'sin') then AResult := Sin(Arg)
    else
    if (LName = 'asinh') or (LName = 'arcsinh') then AResult := ArcSinH(Arg)

    //  COS
    else
    if (LName = 'cos') then AResult := Cos(Arg)

    //  TAN
    else
    if (LName = 'atan') or (LName = 'arctan') then AResult := ArcTan(Arg)

    //  COT (g킯Ȃ)
    else
    if (LName = 'coth') then AResult := CotH(Arg)
    else
    if (LName = 'acot') or (LName = 'arccot') then AResult := ArcCot(Arg)
    else
    if (LName = 'acoth') or (LName = 'arccoth') then AResult := ArcCotH(Arg)

    //  CSC (g킯Ȃ)
    else
    if (LName = 'csc') then AResult := Csc(Arg)
    else
    if (LName = 'csch') then AResult := CscH(Arg)
    else
    if (LName = 'acsc') or (LName = 'arccsc') then AResult := ArcCsc(Arg)
    else
    if (LName = 'acsch') or (LName = 'arccsch') then AResult := ArcCscH(Arg)

    //  SEC (g킯Ȃ)
    else
    if (LName = 'sech') then AResult := SecH(Arg)
    else
    if (LName = 'asec') or (LName = 'arcsec') then AResult := ArcSec(Arg)
    else
    if (LName = 'asech') or (LName = 'arcsech') then AResult := ArcSecH(Arg)



    //  ̊֐̑gݍ킹ŋLqł
    //else
    //if (LName = 'log10') then AResult := Log10(Arg)
    //else
    //if (LName = 'log2') then AResult := Log2(Arg)
    //else
    //if (LName = 'tan') then AResult := Tan(Arg)
    //else
    //if (LName = 'sinh') then AResult := SinH(Arg)
    //else
    //if (LName = 'cosh') then AResult := Cosh(Arg)
    //else
    //if (LName = 'tanh') then AResult := Tanh(Arg)
    //else
    //if (LName = 'asin') or (LName = 'arcsin') then AResult := ArcSin(Arg)
    //else
    //if (LName = 'acos') or (LName = 'arccos') then AResult := ArcCos(Arg)
    //else
    //if (LName = 'acosh') or (LName = 'arccosh') then AResult := ArcCosH(Arg)
    //else
    //if (LName = 'atanh') or (LName = 'arctanh') then AResult := ArcTanH(Arg)
    //else
    //if (LName = 'cot') then AResult := Cot(Arg)
    //else
    //if (LName = 'sec') then AResult := Sec(Arg)



    //  p
    else Result := False;
end;

//-----------------------------------------------------------------------------
//  g֐
function EvalFunc(const Name: String; const Args: array of Variant; var AResult: Variant): Boolean;
begin
    case Length(Args) of
    //  1
     1: Result := EvalFunc1(Name, Args[0], AResult);
    //  2
     2: Result := EvalFunc2(Name, Args, AResult);
    //  3
    // 3: Result := EvalFunc3(Name, Args, AResult);
    //  p(ꏏɂłȋC邯ǈ[͕ϐŏ)
    else  Result := False;
    end;
end;

//=============================================================================
//  TTokenizer

//-----------------------------------------------------------------------------
//  RXgN^
constructor TTokenizer.Create();
begin
    inherited;
    //  K\IuWFNg쐬
    FRegBuf := TRegExp.Create(nil);
    FRegBuf.Global := False;
    FRegBuf.IgnoreCase := False;
    FStrBuf := TStringList.Create();
end;

//-----------------------------------------------------------------------------
//  fXgN^
destructor TTokenizer.Destroy();
begin
    FRegBuf.Free();
    FStrBuf.Free();
    inherited;
end;

//-----------------------------------------------------------------------------
//  K\Ōʂ̈ڂ߂
function TTokenizer.RegMatch(const AText, ARegExp: String): String;
var
    LMatches: OleVariant;
begin
    Result := '';
    FRegBuf.Pattern := ARegExp;
    //  s(ƌʃRNV󂯎)
    LMatches := FRegBuf.Execute(AText);
    //  
    if (LMatches.Count > 0) then
    begin
        Result := LMatches.Item[0].Value;
    end;
end;

//-----------------------------------------------------------------------------
//  Zbg
procedure TTokenizer.SetExpression(const Value: String);
begin
    FExpression := Value;
    FExtracted := '';
end;

(*
//-----------------------------------------------------------------------------
//  ԃRg𕶎񂩂珜 Ƃ [  ] ܂łƂ
//  Rg𒆂ɎȂ番B 
//  gȂ當]OɌĂяoƁB
procedure TTokenizer.PurgeAreaComment(const S, E: Char);
var
    LS, LE: String;
    LRegExp: String;
    LComment: String;
begin
    LS := S;
    LE := E;
    //  K\̓ꕶ̏u(K\Ŋy\肪]vɂ₱)
    if (S in REG_SPECIAL_CHARS) then LS := '\' + LS;
    if (E in REG_SPECIAL_CHARS) then LE := '\' + LE;
    //  JnI(JnȂƂ͖܂)
    LRegExp := Format('%s[^%s]*[%s]{0,1}', [LS, LE, LE]);

    //  Rg𔲂oĎ苎(ЂƂRgȂ1񖳑)
    repeat
        LComment := RegMatch(FExpression, LRegExp);
        FExpression := StringReplace(FExpression, LComment, '', [rfIgnoreCase])
    until
        LComment = '';
end;
*)
//-----------------------------------------------------------------------------
//  K\ňv𖳏ɂ͂
//  ČvẐƂɁAǑvZʂ菜߂
procedure TTokenizer.Remove(const ARegExp: String);
var
    LBuf: String;
begin
    LBuf := RegMatch(FExpression, ARegExp);
    FExpression := StringReplace(FExpression, LBuf, '', []);
end;

//-----------------------------------------------------------------------------
//  s󔒓ǂݔ΂
procedure TTokenizer.SkipBlank(const BlankChars: String);
var
    LBuf: String;
begin
    LBuf := RegMatch(FExpression, Format('^[%s]+', [BlankChars]));
    Delete(FExpression, 1, Length(LBuf));
    FExtracted := FExtracted + LBuf;
end;

//-----------------------------------------------------------------------------
//  2oCg1Ƃ1ǂݎ
function TTokenizer.GetChar(const ReadOnly: Boolean): String;
begin
    SkipBlank();
    Result := RegMatch(FExpression, '.');
    if not ReadOnly then
    begin
        Delete(FExpression, 1, Length(Result));
        FExtracted := FExtracted + Result;
    end;
end;

//-----------------------------------------------------------------------------
//  ̎_̎̍ŏɕǉ
//  2a ̕]G[ł͂Ȃ 2*a ɂ
procedure TTokenizer.InsChar(const AText: String);
begin
    FExpression := AText + FExpression;
end;

//-----------------------------------------------------------------------------
//  sEXP\Őǂݎ
function TTokenizer.GetNumberExp(const ReadOnly: Boolean): String;
begin
    Result := RegMatch(FExpression, '^' + REG_SIGNEDNUM_EXP);
    if not ReadOnly then
    begin
        Delete(FExpression, 1, Length(Result));
        FExtracted := FExtracted + Result;
    end;
end;

//-----------------------------------------------------------------------------
//  ENG\Őǂݎ
function TTokenizer.GetNumberEng(const ReadOnly: Boolean): String;
begin
    Result := RegMatch(FExpression, '^' + REG_SIGNEDNUM_ENG);
    if not ReadOnly then
    begin
        Delete(FExpression, 1, Length(Result));
        FExtracted := FExtracted + Result;
    end;
end;

//-----------------------------------------------------------------------------
//  sϐǂݎ
function TTokenizer.GetWord(const ReadOnly: Boolean): String;
begin
    Result := RegMatch(FExpression, '^' + REG_WORD);
    if not ReadOnly then
    begin
        Delete(FExpression, 1, Length(Result));
        FExtracted := FExtracted + Result;
    end;
end;

//-----------------------------------------------------------------------------
//  sPʂǂݎ
function TTokenizer.GetDimension(const ReadOnly: Boolean = True): String;
begin
    Result := RegMatch(FExpression, '^' + REG_DIMENSION);
    if not ReadOnly then
    begin
        Delete(FExpression, 1, Length(Result));
        FExtracted := FExtracted + Result;
    end;
end;

//=============================================================================
//  ϐ  TVariable

//-----------------------------------------------------------------------------
constructor TVariable.Create();
begin
    Protect := False;
end;

//=============================================================================
//  ϐXg  TVariableList

//-----------------------------------------------------------------------------
procedure TVariableList.ERROR(const AChar, AMsg: String);
begin
    raise Exception.CreateFmt('["%s" %s]', [AChar, AMsg]);
end;

//-----------------------------------------------------------------------------
//  RXgN^
constructor TVariableList.Create();
begin
    inherited;
    FList := TStringList.Create();
    FList.Sorted := False;
    FList.CaseSensitive := False;
    Clear();
    FProtectMode := False;
end;

//-----------------------------------------------------------------------------
//  fXgN^
destructor TVariableList.Destroy();
begin
    Clear();
    FList.Free();
    inherited;
end;

//-----------------------------------------------------------------------------
//  XgNAƒ萔̓o^([hɂ炸10iœo^)
procedure TVariableList.Clear();
begin
    //  XgNA
    while (FList.Count > 0) do
    begin
        FList.Objects[0].Free();
        FList.Delete(0);
    end;
    //  萔̓o^
    SetValue('@', 0);
end;

//-----------------------------------------------------------------------------
//  ϐo(L[͏œ)
function TVariableList.GetVariable(const Name: String): TVariable;
var
    LIndex: Integer;
begin
    Result := nil;
    LIndex := FList.IndexOf(Name);
    if (LIndex <> -1) then
    begin
        Result := TVariable(FList.Objects[LIndex]);
    end;
end;

//-----------------------------------------------------------------------------
//  ϐo 2
function TVariableList.GetVariables(const Index: Integer): TVariable;
begin
    if (Index < 0) or (Index >= Count) then
    begin
        ERROR(IntToStr(Index), 'CfbNXI[o[');
        Result := nil;
    end
    else
    begin
        Result := TVariable(FList.Objects[Index]);
    end;
end;

//-----------------------------------------------------------------------------
//  l擾
function TVariableList.GetValue(const Name: String): Variant;
var
    LValue: TVariable;
begin
    LValue := GetVariable(Name);
    if (LValue <> nil) then
    begin
        Result := LValue.Value;
    end
    else
    begin
        ERROR(Name, 'ϐ`');
        Result := 0;
    end;
end;

//-----------------------------------------------------------------------------
//  ㏑ۂ擾
function TVariableList.GetProtect(const Name: String): Boolean;
var
    LValue: TVariable;
begin
    LValue := GetVariable(Name);
    if (LValue <> nil) then
    begin
        Result := LValue.Protect;
    end
    else
    begin
        ERROR(Name, 'ϐ`');
        Result := True;
    end;
end;

//-----------------------------------------------------------------------------
//  lݒ肷(L[͏œ)
procedure TVariableList.SetValue(const Name: String; const Value: Variant);
var
    LValue: TVariable;
begin
    LValue := GetVariable(Name);
    if (LValue <> nil) then
    begin
        if (not LValue.Protect) then
        begin
            LValue.Value := Value;
        end
        else
        begin
            ERROR(Name, '㏑֎~');
        end;
    end
    else
    begin
        LValue := TVariable.Create();
        LValue.Name := Name;
        LValue.Value := Value;
        LValue.Protect := ProtectMode;
        FList.AddObject(LValue.Name, LValue);
    end;
end;

//-----------------------------------------------------------------------------
//  ㏑ۂݒ肷
procedure TVariableList.SetProtect(const Name: String; const Value: Boolean);
var
    LValue: TVariable;
begin
    LValue := GetVariable(Name);
    if (LValue <> nil) then
    begin
        LValue.Protect := Value;
    end
    else
    begin
        ERROR(Name, 'ϐ`');
    end;
end;

//-----------------------------------------------------------------------------
//  gpĂϐ̌
function TVariableList.GetCount(): Integer;
begin
    Result := FList.Count;
end;

//-----------------------------------------------------------------------------
//  ʂ̃XgRs[Ă
//  Objects ̓eRs[(Oŕێ)
procedure TVariableList.Assign(const Source: TVariableList);
var
    i: Integer;
    LSource: TVariable;
begin
    for i := 0 to Source.Count - 1 do
    begin
        LSource := Source.GetVariables(i);
        Values[LSource.Name] := LSource.Value;
    end;
end;

//-----------------------------------------------------------------------------
//  ϊ
procedure TVariableList.ToString(Strings: TStrings);
var
    i: Integer;
    LValue: TVariable;
    LLine: String;
begin
    for i := 0 to FList.Count - 1 do
    begin
        LValue := GetVariables(i);
        LLine := Format('%s=%s', [LValue.Name, LValue.Value]);
        Strings.Add(LLine);
    end;
end;

//=============================================================================
//  TFunction

//-----------------------------------------------------------------------------
//  RXgN^
constructor TFunction.Create();
begin
    inherited;
    Param := TStringList.Create();
    Protect := False;
end;

//-----------------------------------------------------------------------------
//  fXgN^
destructor TFunction.Destroy();
begin
    Param.Free();
    inherited;
end;

//=============================================================================
//  TFunctionList

//-----------------------------------------------------------------------------
//  ֐o^(̊֐Ώ㏑BłƎv)
function TFunctionList.RegistFunction(const Name, Params, Expression: String): Boolean;
var
    LValue: TFunction;
begin
    //  {͂ňƎ̐`FbNǌ
    Result := True;

    LValue := GetFunction(Name);
    if (LValue <> nil) then
    begin
        if (not LValue.Protect) then
        begin
            LValue.Name := Name;
            LValue.Param.CommaText := Params;
            LValue.Expression := Expression;
            LValue.Protect := ProtectMode;
        end
        else
        begin
            ERROR(Name, '㏑֎~');
        end;
    end
    else
    begin
        LValue := TFunction.Create();
        LValue.Name := Name;
        LValue.Param.CommaText := Params;
        LValue.Expression := Expression;
        LValue.Protect := ProtectMode;
        FList.AddObject(LValue.Name, LValue);
    end;
end;

//-----------------------------------------------------------------------------
procedure TFunctionList.ERROR(const AChar, AMsg: String);
begin
    raise Exception.CreateFmt('["%s" %s]', [AChar, AMsg]);
end;

//-----------------------------------------------------------------------------
//  RXgN^
constructor TFunctionList.Create();
begin
    inherited;
    FList := TStringList.Create();
    FList.Sorted := False;
    FList.CaseSensitive := False;
    Clear();
    FProtectMode := False;
end;

//-----------------------------------------------------------------------------
//  fXgN^
destructor TFunctionList.Destroy();
begin
    Clear();
    FList.Free();
    inherited;
end;

//-----------------------------------------------------------------------------
//  XgNA
procedure TFunctionList.Clear();
begin
    while (FList.Count > 0) do
    begin
        FList.Objects[0].Free();
        FList.Delete(0);
    end;
end;

//-----------------------------------------------------------------------------
//  ֐o
function TFunctionList.GetFunction(const Name: String): TFunction;
var
    LIndex: Integer;
begin
    Result := nil;
    LIndex := FList.IndexOf(Name);
    if (LIndex <> -1) then
    begin
        Result := TFunction(FList.Objects[LIndex]);
    end;
end;

//-----------------------------------------------------------------------------
//  ֐o 2
function TFunctionList.GetFunctions(const Index: Integer): TFunction;
begin
    if (Index < 0) or (Index >= Count) then
    begin
        ERROR(IntToStr(Index), 'CfbNXI[o[');
        Result := nil;
    end
    else
    begin
        Result := TFunction(FList.Objects[Index]);
    end;
end;

//-----------------------------------------------------------------------------
//  擾
function TFunctionList.GetExpression(const Name: String): String;
var
    LValue: TFunction;
begin
    LValue := GetFunction(Name);
    if (LValue <> nil) then
    begin
        Result := LValue.Expression;
    end
    else
    begin
        ERROR(Name, '֐`');
        Result := '';
    end;
end;

//-----------------------------------------------------------------------------
//  Xg擾
function TFunctionList.GetParam(const Name: String): TStringList;
var
    LValue: TFunction;
begin
    LValue := GetFunction(Name);
    if (LValue <> nil) then
    begin
        Result := LValue.Param;
    end
    else
    begin
        ERROR(Name, '֐`');
        Result := nil;
    end;
end;

//-----------------------------------------------------------------------------
//  ㏑ۂ擾
function TFunctionList.GetProtect(const Name: String): Boolean;
var
    LValue: TFunction;
begin
    LValue := GetFunction(Name);
    if (LValue <> nil) then
    begin
        Result := LValue.Protect;
    end
    else
    begin
        ERROR(Name, '֐`');
        Result := False;
    end;
end;

//-----------------------------------------------------------------------------
//  ㏑ۂݒ肷
procedure TFunctionList.SetProtect(const Name: String; const Value: Boolean);
var
    LValue: TFunction;
begin
    LValue := GetFunction(Name);
    if (LValue <> nil) then
    begin
        LValue.Protect := Value;
    end
    else
    begin
        ERROR(Name, '֐`');
    end;
end;

//-----------------------------------------------------------------------------
//  gpĂ֐̌
function TFunctionList.GetCount(): Integer;
begin
    Result := FList.Count;
end;

//-----------------------------------------------------------------------------
//  ʂ̃XgRs[Ă
//  Objects ̓eRs[(Oŕێ)
procedure TFunctionList.Assign(const Source: TFunctionList);
var
    i: Integer;
    LSource: TFunction;
    LDest: TFunction;
begin
    for i := 0 to Source.Count - 1 do
    begin
        LSource := Source.GetFunctions(i);
        LDest := TFunction.Create();
        LDest.Name := LSource.Name;
        LDest.Param.Assign(LSource.Param);
        LDest.Expression := LSource.Expression;
        FList.AddObject(LDest.Name, LDest);
    end;
end;

//-----------------------------------------------------------------------------
//  ϊ
procedure TFunctionList.ToString(Strings: TStrings);
var
    i: Integer;
    LValue: TFunction;
    LLine: String;
begin
    for i := 0 to FList.Count - 1 do
    begin
        LValue := GetFunctions(i);
        LLine := Format('%s(%s)=%s', [LValue.Name, LValue.Param.CommaText, LValue.Expression]);
        Strings.Add(LLine);
    end;
end;

end.
